use `ombutel`;

alter table `ombutel`.`ombu_sip_profiles`
	add column `codecs` varchar(255) not null default 'ulaw,alaw,g729',
	add column `videosupport` enum('always','yes','no') not null default 'no',
	add column `maxcallbitrate` int unsigned not null default 384,
	add column `preferred_codec_only` enum('no','yes') not null default 'no',
	add column `autoframing` enum('no','yes') not null default 'no';

alter table `ombutel`.`ombu_cloudphone_profiles`
	add column `videosupport` enum('always','yes','no') not null default 'always',
	add column `maxcallbitrate` int unsigned not null default 384,
	add column `preferred_codec_only` enum('no','yes') not null default 'no',
	add column `autoframing` enum('no','yes') not null default 'no';

alter table `ombutel`.`ombu_sip_trunks`
	add column `videosupport` enum('always','yes','no') not null default 'no',
	add column `maxcallbitrate` int unsigned not null default 384,
	add column `preferred_codec_only` enum('no','yes') not null default 'no',
	add column `autoframing` enum('no','yes') not null default 'no',
	modify column `codecs` varchar(255) not null default 'ulaw,alaw,g729';

-- Copy SIP general parameters to SIP profiles
update `ombutel`.`ombu_sip_profiles` p
left join `ombutel`.`ombu_modules` m on (m.`name` = 'sip_settings')
left join `ombutel`.`ombu_settings` s on (s.`module_id` = m.`module_id` and s.`name` = 'allowedcodecs')
	set p.`codecs` = coalesce(s.`value`, 'ulaw,alaw,g729');

update `ombutel`.`ombu_sip_profiles` p
left join `ombutel`.`ombu_modules` m on (m.`name` = 'sip_settings')
left join `ombutel`.`ombu_settings` s on (s.`module_id` = m.`module_id` and s.`name` = 'videosupport')
	set p.`videosupport` = coalesce(s.`value`, 'no');

update `ombutel`.`ombu_sip_profiles` p
left join `ombutel`.`ombu_modules` m on (m.`name` = 'sip_settings')
left join `ombutel`.`ombu_settings` s on (s.`module_id` = m.`module_id` and s.`name` = 'maxcallbitrate')
	set p.`maxcallbitrate` = coalesce(s.`value`, 384);

update `ombutel`.`ombu_sip_profiles` p
left join `ombutel`.`ombu_modules` m on (m.`name` = 'sip_settings')
left join `ombutel`.`ombu_settings` s on (s.`module_id` = m.`module_id` and s.`name` = 'preferred_codec_only')
	set p.`preferred_codec_only` = coalesce(s.`value`, 'no');

update `ombutel`.`ombu_sip_profiles` p
left join `ombutel`.`ombu_modules` m on (m.`name` = 'sip_settings')
left join `ombutel`.`ombu_settings` s on (s.`module_id` = m.`module_id` and s.`name` = 'autoframing')
	set p.`autoframing` = coalesce(s.`value`, 'no');

-- Copy SIP general parameters to CloudPhone profiles
update `ombutel`.`ombu_cloudphone_profiles` p
left join `ombutel`.`ombu_modules` m on (m.`name` = 'sip_settings')
left join `ombutel`.`ombu_settings` s on (s.`module_id` = m.`module_id` and s.`name` = 'maxcallbitrate')
	set p.`maxcallbitrate` = coalesce(s.`value`, 384);

update `ombutel`.`ombu_cloudphone_profiles` p
left join `ombutel`.`ombu_modules` m on (m.`name` = 'sip_settings')
left join `ombutel`.`ombu_settings` s on (s.`module_id` = m.`module_id` and s.`name` = 'preferred_codec_only')
	set p.`preferred_codec_only` = coalesce(s.`value`, 'no');

update `ombutel`.`ombu_cloudphone_profiles` p
left join `ombutel`.`ombu_modules` m on (m.`name` = 'sip_settings')
left join `ombutel`.`ombu_settings` s on (s.`module_id` = m.`module_id` and s.`name` = 'autoframing')
	set p.`autoframing` = coalesce(s.`value`, 'no');

-- Copy SIP general parameters to SIP trunks
update `ombutel`.`ombu_sip_trunks` t
left join `ombutel`.`ombu_modules` m on (m.`name` = 'sip_settings')
left join `ombutel`.`ombu_settings` s on (s.`module_id` = m.`module_id` and s.`name` = 'videosupport')
	set t.`videosupport` = coalesce(s.`value`, 'no');

update `ombutel`.`ombu_sip_trunks` t
left join `ombutel`.`ombu_modules` m on (m.`name` = 'sip_settings')
left join `ombutel`.`ombu_settings` s on (s.`module_id` = m.`module_id` and s.`name` = 'maxcallbitrate')
	set t.`maxcallbitrate` = coalesce(s.`value`, 384);

update `ombutel`.`ombu_sip_trunks` t
left join `ombutel`.`ombu_modules` m on (m.`name` = 'sip_settings')
left join `ombutel`.`ombu_settings` s on (s.`module_id` = m.`module_id` and s.`name` = 'preferred_codec_only')
	set t.`preferred_codec_only` = coalesce(s.`value`, 'no');

update `ombutel`.`ombu_sip_trunks` t
left join `ombutel`.`ombu_modules` m on (m.`name` = 'sip_settings')
left join `ombutel`.`ombu_settings` s on (s.`module_id` = m.`module_id` and s.`name` = 'autoframing')
	set t.`autoframing` = coalesce(s.`value`, 'no');

update `ombutel`.`ombu_sip_trunks` t
left join `ombutel`.`ombu_modules` m on (m.`name` = 'sip_settings')
left join `ombutel`.`ombu_settings` s on (s.`module_id` = m.`module_id` and s.`name` = 'allowedcodecs')
	set t.`codecs` = coalesce(s.`value`, 'ulaw,alaw,g729')
where t.`codecs` = '';

-- Generate anonymous SIP profile
insert into `ombutel`.`ombu_device_profiles` (`technology`, `name`, `description`, `default`)
	values ('sip', 'Default Anonymous Profile', 'Default Anonymous Profile', 'no');
select last_insert_id() into @profile_id;
insert into `ombutel`.`ombu_sip_profiles` (`profile_id`, `host`, `peertype`, `qualify`,
	`qualifyfreq`, `transport`, `icesupport`, `encryption`, `avpf`,
	`directmedia`, `sendrpid`, `trustrpid`, `videosupport`, `maxcallbitrate`,
	`preferred_codec_only`, `autoframing`, `codecs`)
	select @profile_id, 'dynamic', 'friend', 2000, 60, 'udp', 'no', 'no',
	'no', 'nonat', 'no', 'yes', 'no', 384, 'no', 'no', s.`value`
	from `ombutel`.`ombu_modules` m
	left join `ombutel`.`ombu_settings` s on (s.`module_id` = m.`module_id`)
	where m.`name` = 'sip_settings'
	and s.`name` = 'allowedcodecs';
insert into `ombutel`.`ombu_settings` (`module_id`, `name`, `value`)
select `module_id`, 'anonymous_profile', @profile_id
	from `ombutel`.`ombu_modules`
	where `name` = 'sip_settings';

-- Delete obsolete SIP general parameters
delete s from `ombu_modules` m
left join `ombu_settings` s on (s.`module_id` = m.`module_id`)
where m.`name` = 'sip_settings' and s.`name` in
	('videosupport', 'maxcallbitrate', 'preferred_codec_only', 'autoframing', 'allowedcodecs');
