$(function(){
	$("a[href='#tab_epm_pairing'] i.reload-tab").remove();
	var enabled = $("#epm_pairinggeneral #enabled");
	var qrcode = $("#epm_pairinggeneral .qr-code img");
	if (enabled) {
		var time_remaining = $("#epm_pairinggeneral #time_remaining");
		var flip_button_to = function(element, value) { // bootstrap sucks
			element.find("input").removeAttr("checked").parent().removeClass("active");
			element.find("input[value="+value+"]").prop("checked", "checked").parent().addClass("active");
		};
		var calculate_remaining = function() {
			var end = new Date(time_remaining.data("end") * 1000);
			var now = new Date();
			return Math.floor(Math.max(0, (end.getTime() - now.getTime()) / 1000));
		};
		var update_timer = function() {
			var remaining_time = calculate_remaining();
			if (remaining_time > 0) {
				qrcode.show();
			} else {
				flip_button_to(enabled, " 0");
				qrcode.hide();
			}
			var minutes = ("00"+Math.floor(remaining_time / 60)).slice(-2);
			var seconds = ("00"+(remaining_time % 60)).slice(-2);
			time_remaining.val(minutes+":"+seconds);
		};
		var reset_timer = function() {
			$.ajax({
				type: "POST",
				url: CallBack,
				dataType: "html",
				data: { class: "epm_pairing", method: "reset" }
			});
			time_remaining.data("end", (new Date().getTime() / 1000) + 1800); // reset to 30 minutes
			flip_button_to(enabled, "1");
			qrcode.show();
			update_timer();
		};
		var stop_timer = function() {
			$.ajax({
				type: "POST",
				url: CallBack,
				dataType: "html",
				data: { class: "epm_pairing", method: "stop" }
			});
			time_remaining.data("end", 0);
			flip_button_to(enabled, "0");
			qrcode.hide();
			update_timer();
		};
		enabled.change(function() {
			if (enabled.find("input:checked").val() == 1) {
				reset_timer();
			} else {
				stop_timer();
			}
		});
		$("#epm_pairinggeneral button.epm_reset").click(function() {
			if (calculate_remaining() > 0) {
				reset_timer();
			}
		});
		register_timer("epm_pairing", "update_timer", update_timer, 1000, true);
	}
});
